/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.lms;

import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerAction;
import jp.co.ntt.lms.installer.core.InstallerActionValue;
import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;

/**
 * インストールするＬＯ選択のユーザ入力を求めるアクションクラス。<br>
 *
 * @author T.Nishiki
 */
public class SelectLoAction implements InstallerAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(SelectLoAction.class);
	}

	/**
	 * アクションをスキップするか判定します。<br>
	 * スキップしません。常にfalseを戻します。
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return 常にfalseを戻します。
	 */
	public boolean isSkipped(InstallerValues values) {
		return false;
	}

	/**
	 * LOのインストール選択をユーザ確認します。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return nullを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	public InstallerActionValue action(InstallerValues values)
			throws InstallerException {

		LoggerUtil.methodHead(_logger, "action(InstallerValues)");

		try {
			// タイトル表示
			InstallerUiUtil.outputMessageAsTitle(
				values, "SelectLoAction.welcome");

			while (true) {
				// 入力実行
				readInputValue(values);
				// 入力確認
				if (confirmInputValue(values) == true) {
					break;
				}
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger, "action(InstallerValues)");
		return null;
	}

	/**
	 *LOの選択について入力を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private void readInputValue(InstallerValues values)
			throws InstallerException {
		LoggerUtil.methodHead(_logger,
			"readInputValue(InstallerValues)");

		try {
			String[] optionLOKeys = values.getOptionLOKeys();
			for (int i = 0; i < optionLOKeys.length; i++) {
				String loName = values.getMessage(
					"common.optionLO.name." + optionLOKeys[i]);
				Object[] messageParams = new Object[] {
					loName
				};
				boolean loSelection
					= InstallerUiUtil.askUserConfirm(
						values, "common.optionLO.prompt", messageParams );
				values.setOptionLOSelected(optionLOKeys[i], loSelection);
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"readInputValue(InstallerValues)");
	}

	/**
	 * 入力した内容を表示し、ユーザに確認を求めます。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return 入力された内容にユーザ確認がとれた場合true、
	 *          とれなかった場合falseを戻します。
	 * @throws InstallerException 処理中にエラーが発生した場合。
	 */
	private boolean confirmInputValue(InstallerValues values)
			throws InstallerException {

		LoggerUtil.methodHead(_logger,
			"confirmInputValue(InstallerValues, SelectLoValue)");
		boolean confirm = false;
		try {
			InstallerUiUtil.outputConfirmTitle(values,
				"SelectLoAction.confirm.title");
			// =================================================================
			// 入力内容の表示
			String[] optionLOKeys = values.getOptionLOKeys();
			for (int i = 0; i < optionLOKeys.length; i++) {
				InstallerUiUtil.outputConfirm(values,
					"common.optionLO.name." + optionLOKeys[i],
					InstallerUiUtil.convertBoolToConfirmString(
						values.getOptionLOSelected(optionLOKeys[i])));
			}
			// =================================================================
			// ユーザ確認
			confirm = InstallerUiUtil.askUserConfirm(
				values, "SelectLoAction.confirm" );
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"confirmInputValue(InstallerValues, SelectLoValue)",
			confirm);
		return confirm;
	}
}
